% !TeX TS-program = lualatex
% !TeX spellcheck = en_US


\documentclass[
ngerman,%globale Übergabe der Hauptsprache
aspectratio=169,%Beamer eigene Option zum Umschalten des Formates
color={accentcolor=2d},
logo=true,%Kein Logo auf Folgeseiten
colorframetitle=true,%Akzentfarbe auch im Frametitle
%	logofile=example-image, %Falls die Logo Dateien nicht vorliegen
]{tudabeamer}
\usepackage[main=english]{babel}




%Makros für Formatierungen der Doku
%Im Allgemeinen nicht notwendig!
\let\code\texttt
\newcommand{\ceil}[1]{\lceil {#1} \rceil}

% add some space to itemize lists
\newlength{\wideitemsep}
\setlength{\wideitemsep}{\itemsep}
\addtolength{\wideitemsep}{8pt}
\let\olditem\item
\renewcommand{\item}{\setlength{\itemsep}{\wideitemsep}\olditem}


\title{	Lossless/Lossy Volume Data Compression}
\subtitle{PMPP project - first status presentation}
\author[N. Beck \and P. Hollmann]{Niklas Beck \and Paul Hollmann}
\department{Programming Massively Parallel Processors}
\institute{Lossless/Lossy Volume Data Compression}

%Fremdlogo
%Logo Macro mit Sternchen skaliert automatisch, sodass das Logo in die Fußzeile passt
\logo*{\includegraphics{ce_logo_black.pdf}}

% Da das Bild frei wählbar nach Breite und/oder Höhe skaliert werden kann, werden \width/\height entsprechend gesetzt. So kann die Fläche optimal gefüllt werden.
%Sternchenversion skaliert automatisch und beschneidet das Bild, um die Fläche zu füllen.
\titlegraphic{\includegraphics[height=.75\textheight]{carp}}
\date{22. Nov 2021}

\begin{document}
	
	\maketitle	
	\section{Compression}
	\begin{frame}{Compression: Bricking}
		\begin{itemize}
			\item volume data is stored uncompressed as a set of voxels {\small i.e. RGB data}
			
			\item split full volume data into \textit{bricks} of size $4 \times 4 \times 4 = 64$
			
			\item references to bricks: \textit{offset volume}
			
			\item bricks are saved with min and max values
			\begin{itemize}
				\item iff min and max different: voxel data is transformed + compressed inside a codeword
			\end{itemize}
		
			\item list of codewords ($cw$): \textit{codebook}
	 	\end{itemize}
	\end{frame}

	\begin{frame}{Compression: (lossless) Transforms}
		\begin{itemize}
			\item one of 3 transformation selected per brick:
			\item Subtract Minimum/Maximum
			\begin{itemize}
				\item only store the difference to min/max 
			\end{itemize}
			\item Gradient Predictor
%			\begin{itemize}
%				\item
%			\end{itemize}
			\item Haar Wavelet
%			\begin{itemize}
%				\item
%			\end{itemize}
		\end{itemize}
	\end{frame}		
	
	\begin{frame}{Compression: Codewords}
		\begin{itemize}
			\item based on recursive bottom up complete (\textit{RBUC})
			\item saved in tree-like structure for $4^3 = 64$ voxel in 8 leaves containing 8 voxel
			\item root $c_2$ contains bit-size of each child node {\small(last 6 bits)} and a transformation id {\small(first 2 bits)}
			\item inner nodes $c_1$ contain bit-size of the leaves below them
			\item leaves/ last layer $c_0$ contain all voxel in the provided number of bit
		\end{itemize}
	\end{frame}	

	
	\begin{frame}{Compression: Offset Volume and Codebook}
		\begin{itemize}
			\item starting address of bricks needed for random access
			\item for different-sized codewords some form of mapping between Offset Volume and codewords
			\begin{itemize}
				\item offset volume might contain directly the starting address
				\item additional data structure might map by index to starting address
			\end{itemize}
			\item if constant size of uncompressed codebook the address is multiple of index and fixed brick size
			\item search codebook for same words $\rightarrow$ filter them out $\rightarrow$ save the multiplicity 
		\end{itemize}
	\end{frame}	

	
	\begin{frame}{Compression: $k$-means clustering (vector quantization) 1}
		\begin{itemize}
			\item Idea: reduce codebook with $N$ unique entries to $k$ codewords {\small (with minimal data loss)}
			\item [] \textbf{Algorithm} (init):
		\end{itemize}
	
		\begin{enumerate}
			\item find codeword ($cw$) closest to origin $\rightarrow$ first cluster center ($c$)
			\item create cluster centers at $cw$'s that are furthest away from all existing $c$'s
			\item[$\rightarrow$] {{\small for small data and compression:} use priority queue, start with furthest $cw$, check distance to all $c$'s, if still smaller then second $cw$ make it a new $c$}
			\item assign all $cw$'s to closest $c$
		\end{enumerate}
	\end{frame}	

	\begin{frame}{Compression: $k$-means clustering (vector quantization) 2}
		\begin{itemize}
			\item [] \textbf{Algorithm} (iteration):
		\end{itemize}
		
		\begin{enumerate}
			\item update $c$'s to the average of its $cw$'s {\small(weighted with multiplicity)}
			\item assign each $cw$ to the closest $c$
			\begin{itemize}
				\item if distance to old $c$ is smaller: only check against changed $c$'s
				\item if distance bigger: check against all $c$'s
				\item if distance is 0: NOP
			\end{itemize}
			\item mark changed/unchanged $c$'s
			\item if no changed $c$'s $\rightarrow$ convergence $\rightarrow$ finished  
		\end{enumerate}
	\end{frame}	

	\section{Outline}
	\begin{frame}{Project Outline}
		\framesubtitle{general working topics and first ideas}
		\begin{itemize}
			\item \textbf{optimize block/brick compression (codeword generation)}
			\begin{itemize}
				\item [A] compute the \textit{transformations} of each \textit{brick} separate (in parallel)
				\item [B] compute the three \textit{transformations} of each \textit{brick} in separate (parallel) calls
				\item [C] find way to compute each \textit{transformation} with more than one thread (maybe)
			\end{itemize}
		
		
			\item \textbf{optimize vector quantization code}
		
			\begin{itemize}
				\item [A] relaxation of \textit{codewords} and recomputing of \textit{cluster}-centers (GPU)
				\item [B] setup initial \textit{clusters} and order \textit{codewords} (maybe GPU)
			
			\end{itemize}
			\item [both] \qquad \small organize \textit{codebook} {\footnotesize(remove duplicates ...)} (CPU or maybe GPU)
		\end{itemize}
	\end{frame}	
	
\end{document}
